unit Question3_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons;

type
  TfrmQuestion3 = class(TForm)
    redOutput: TRichEdit;
    pnlButtons: TPanel;
    btnA: TButton;
    btnB: TButton;
    BitBtn1: TBitBtn;
    procedure btnAClick(Sender: TObject);
    procedure btnBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQuestion3: TfrmQuestion3;
  iCountRefs : integer;
  arrRefs, arrQueries : array[1..100] of String;

implementation
{$R *.dfm}
procedure CreateSuggestionsFile;
var
  sFile : textfile;
begin
  AssignFile(sFile, 'suggestions.txt');
  ReWrite(sFile);
  CloseFile(sFile);
end;

function  validateAccNum(sAccNum:String): boolean;
var
  bValid : boolean;
begin
      bValid := false;
      if (length(sAccNum) = 7)  and (upcase(sAccNum[1])
      in ['A'..'Z'])  then
        begin
            bValid := true;
        end;
      result := bValid;
end;


procedure TfrmQuestion3.btnAClick(Sender: TObject);
var
  inFile, sugFile : textfile;
  sLine, sAccNum, sQuery, sDate, sQueryType, sRefNum : String;
  iLoop, iComCount, iAccCount : integer;
begin
  CreateSuggestionsFile;

  AssignFile(inFile, 'Data.txt'); 
  Reset(inFile);

  iCountRefs := 0;
  iComCount := 0;
  iAccCount := 0;

  while NOT EOF (inFile) do
    begin
      ReadLn(inFile, sLine);
      
      sQueryType := Copy(sLine, 1, Pos(':', sLine) - 1);
      Delete(sLine, 1, Pos(':', sLine));

      sAccNum := Copy(sLine, 1, Pos(':', sLine) - 1);
      Delete(sLine, 1, Pos(':', sLine));

      sDate := Copy(sLine, 1, Pos('#', sLine) - 1);
      Delete(sLine, 1, Pos('#', sLine));

      sQuery := sLine;

      if (validateAccNum(sAccNum)) then
        begin
          if (sQueryType = 'Suggestion') then
            begin
              AssignFile(sugFile, 'Suggestions.txt');
              Append(sugFile);

              WriteLn(sugFile, sAccNum + ':' + sDate + '#' + sQuery);

              CloseFile(sugFile);
            end
          else
            begin
              Inc(iCountRefs);
              sRefNum := sQueryType[1];

              if (sQueryType = 'Complaint') then
                begin
                  Inc(iComCount);
                  sRefNum := sRefNum + IntToStr(iComCount);
                end
              else if (sQueryType = 'Account') then
                begin
                  Inc(iAccCount);
                  sRefNum := sRefNum + IntToStr(iAccCount);
                end;

              sRefNum := sRefNum + '-' + sAccNum + '-' + sDate;
              arrRefs[iCountRefs] := sRefNum;
              arrQueries[iCountRefs] := sQuery;
            end;
        end;
       btnB.Enabled := true;
    end;

  redOutput.Lines.Clear;

  redOutput.Lines.Add('Reference Numbers');
  redOutput.Lines.Add('=================');

  for iLoop := 1 to iCountRefs do
    begin
      redOutput.Lines.Add(arrRefs[iLoop]);
    end;

  CloseFile(inFile);


end;

procedure TfrmQuestion3.btnBClick(Sender: TObject);
var
  sAccNum : String;
  iLoop   : integer;
  bFound  : boolean;
begin
  sAccNum := Uppercase(InputBox('Search Queries',   'Enter the account number', ''));
  redOutput.Lines.Clear;
  bFound := false;

  if NOT(validateAccNum(sAccNum)) then
      ShowMessage('Invalid account number')
  else
    begin 
      for iLoop := 1 to iCountRefs do
        begin
          if (Pos(sAccNum, arrRefs[iLoop]) > 0)   then
            begin
              redOutput.Lines.Add(arrRefs[iLoop] + #9 + arrQueries[iLoop]);
              bFound := true;
            end;
        end;
      if bFound = false then
        begin
   redOutput.Lines.Add('No issues have been reported for account number: ' + sAccNum);
        end;
     end; // else
 end;


end.
